﻿<AML>
 <Item type="Method" id="0B1B70334DAD4406A3DAB95F259C3BE4" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_sale_add_line_allocation
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -Adding 5 row in Sale Invoice Allocation with null value.

            Hooks:
                Type:		ItemType : sop_sale_invoice
                Event:		Server Events ( onAfterAdd )
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_sale_add_line_allocation";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                Item check_allocation = myInnovator.newItem("sop_sale_allocation", "get");
                check_allocation.setProperty("source_id", _id);
                check_allocation.setPropertyCondition("source_id", "eq");
                check_allocation = check_allocation.apply();
                if (!check_allocation.isError() && check_allocation.getItemCount() > 0)
                {
                    //nothing do
                }
                else
                {
                    for (int i = 0; i < 4; i++)
                    {
                        Item auto_allocation = myInnovator.newItem("sop_sale_allocation", "add");
                        auto_allocation.setProperty("acc_gl_code", "");
                        auto_allocation.setProperty("acc_gl_code_number", "");
                        auto_allocation.setProperty("acc_department_so_no", "");
                        auto_allocation.setProperty("acc_department_so_name", "");
                        auto_allocation.setProperty("acc_amount", "0");
                        auto_allocation.setProperty("acc_x_amount", "0");
                        auto_allocation.setProperty("source_id", _id);
                        auto_allocation = auto_allocation.apply();
                    }

                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_sale_add_line_allocation</name>
 </Item>
</AML>